#Admin Plugin by gkl21
#Dec 29, 2007
#Edit the moderators file from IRC

#Define the package name. Stick to file names. MUST match the according name in .xml.
package admin;

#Define Perl Plugins
use POE;
use plugin;

#Required
our $plugin_name;
our %config;

my $currentVersion = 1.02;

#These commands are pointers to subs.
#Syntax: "Call_This" => "GoTo_This_Sub"
our %additional_events =
(
	"admin" => "admin",
	"1" => "1"
);

#Initialize the plugin
sub start
{
	my ( $session, $heap, $args ) = @_[ SESSION, HEAP, ARG0 ];
	my $kernel = $_[KERNEL];

	my $dbVersion = plugin::get_global ( "version_plugin_admin" );
	if ( !$dbVersion ) { $dbVersion = 1.0; }

	if ( $dbVersion != $currentVersion )
	{
		plugin::set_global ( "version_plugin_admin", $currentVersion );
	}
	
}

sub stop
{
	my ( $session, $heap, $args ) = @_[ SESSION, HEAP, ARG0 ];
	my $kernel = $_[KERNEL];

}

#Remember that <event> within the .xml file. Well, here is how to handle it.
#command() - !irc commands
sub command
{
	# trigger on !commands
	my ( $session, $heap, $args ) = @_[ SESSION, HEAP, ARG0 ];
	my $kernel = $_[KERNEL];
	my %args = %{$args};
	
	if ($args{command} eq "admin") #command name in xml file
	{
		$kernel->yield("admin" => \%args); #sub routing name
	}
}


sub admin
{
	my ( $session, $heap, $args ) = @_[ SESSION, HEAP, ARG0 ];
	my $kernel = $_[KERNEL];
	my %args = %{$args};

	my $action = "$args{arg1}";
	my $nick = "$args{arg2}";
	my $level = "$args{arg3}";
	my $match = "false";
	my $tmp;
	my $moved = "false";

	$nickcom = $nick;
	$nickcom =~ tr/A-Z/a-z/;

	if ( $nick ) {
		if ( $action eq "add" ) {
			if ( $level ) {
				open (MODFILE, $brconfig::config_moderatorsfile);
				while (<MODFILE>) {
					chomp;
					$tmp = "$_";
					$com = $tmp;
					$com =~ s/\s+$//;
					$com =~ tr/A-Z/a-z/;
					if ( $com eq $nickcom ) { $match = "true"; }
				}
				close (MODFILE);
				if ( $match eq "true" ) {
					open (MODFILE, $brconfig::config_moderatorsfile);
					open (MODFILE2, '>'.$brconfig::config_moderatorsfile.'2');
					while (<MODFILE>) {
						chomp;
						$tmp = "$_";
						$tmp =~ s/\s+$//;
						$com = $tmp;
						$com =~ tr/A-Z/a-z/;
						if ( $com eq $nickcom ) { }
						else { print MODFILE2 "$tmp\n"; }
					}				
					close (MODFILE);
					close (MODFILE2);
					open (MODFILE, $brconfig::config_moderatorsfile.'2');
					open (MODFILE2, '>'.$brconfig::config_moderatorsfile);
					while (<MODFILE>) {
						chomp;
						$tmp = "$_";
						$tmp =~ s/\s+$//;
						print MODFILE2 "$tmp\n";	
					}				
					close (MODFILE);
					close (MODFILE2);
					$moved = "true";

				}
				if ( $level eq "1" ) {
				#HALF_MODS
					open (MODFILE, $brconfig::config_moderatorsfile);
					open (MODFILE2, '>'.$brconfig::config_moderatorsfile.'2');
					while (<MODFILE>) {
						chomp;
						$tmp = "$_";
						$tmp =~ s/\s+$//;
						print MODFILE2 "$tmp\n";	
						if ( $tmp eq "[HALF_MODS]" ) { print MODFILE2 "$nick\n"; }
					}				
					close (MODFILE);
					close (MODFILE2);
					open (MODFILE, $brconfig::config_moderatorsfile.'2');
					open (MODFILE2, '>'.$brconfig::config_moderatorsfile);
					while (<MODFILE>) {
						chomp;
						$tmp = "$_";
						$tmp =~ s/\s+$//;
						print MODFILE2 "$tmp\n";	
					}				
					close (MODFILE);
					close (MODFILE2);
					if ( $moved eq "true" ) { plugin::ircmsg ( "[BR]".chr(2)." [ModControl]".chr(2).": $nick has been moved to the HALF_MODS list. Type !rehash when all changes are completed.", $args{'ircChannelCode'} ); }
					else { plugin::ircmsg ( "[BR]".chr(2)." [ModControl]".chr(2).": $nick has been added to the HALF_MODS list. Type !rehash when all changes are completed.", $args{'ircChannelCode'} ); }
				}
				elsif ( $level eq "2" ) {
				#FULL_MODS
					open (MODFILE, $brconfig::config_moderatorsfile);
					open (MODFILE2, '>'.$brconfig::config_moderatorsfile.'2');
					while (<MODFILE>) {
						chomp;
						$tmp = "$_";
						$tmp =~ s/\s+$//;
						print MODFILE2 "$tmp\n";	
						if ( $tmp eq "[FULL_MODS]" ) { print MODFILE2 "$nick\n"; }
					}				
					close (MODFILE);
					close (MODFILE2);
					open (MODFILE, $brconfig::config_moderatorsfile.'2');
					open (MODFILE2, '>'.$brconfig::config_moderatorsfile);
					while (<MODFILE>) {
						chomp;
						$tmp = "$_";
						$tmp =~ s/\s+$//;
						print MODFILE2 "$tmp\n";	
					}				
					close (MODFILE);
					close (MODFILE2);
					if ( $moved eq "true" ) { plugin::ircmsg (  "[BR]".chr(2)." [ModControl]".chr(2).": $nick has been moved to the FULL_MODS list. Type !rehash when all changes are completed.", $args{'ircChannelCode'} ); }
					else { plugin::ircmsg ( "[BR]".chr(2)." [ModControl]".chr(2).": $nick has been added to the FULL_MODS list. Type !rehash when all changes are completed.", $args{'ircChannelCode'} ); }
				}
				elsif ( $level eq "3" ) {
				#ADMINS
					open (MODFILE, $brconfig::config_moderatorsfile);
					open (MODFILE2, '>'.$brconfig::config_moderatorsfile.'2');
					while (<MODFILE>) {
						chomp;
						$tmp = "$_";
						$tmp =~ s/\s+$//;
						print MODFILE2 "$tmp\n";	
						if ( $tmp eq "[ADMINS]" ) { print MODFILE2 "$nick\n"; }
					}				
					close (MODFILE);
					close (MODFILE2);
					open (MODFILE, $brconfig::config_moderatorsfile.'2');
					open (MODFILE2, '>'.$brconfig::config_moderatorsfile);
					while (<MODFILE>) {
						chomp;
						$tmp = "$_";
						$tmp =~ s/\s+$//;
						print MODFILE2 "$tmp\n";	
					}				
					close (MODFILE);
					close (MODFILE2);
					if ( $moved eq "true" ) { plugin::ircmsg ( "[BR]".chr(2)." [ModControl]".chr(2).": $nick has been moved to the ADMINS list. Type !rehash when all changes are completed.", $args{'ircChannelCode'} ); }
					else { plugin::ircmsg ( "[BR]".chr(2)." [ModControl]".chr(2).": $nick has been added to the ADMINS list. Type !rehash when all changes are completed.", $args{'ircChannelCode'} ); }
				}
				else {
					plugin::ircmsg ( "[BR]".chr(2)." [ModControl]".chr(2).": Invalid level defined. 1 - HALF_MODS, 2 - FULL_MODS, 3 - ADMINS.", $args{'ircChannelCode'} );
				}

			}
			else {
				plugin::ircmsg ( "[BR]".chr(2)." Usage".chr(2).": !admin <add|del> <nick> <level>", $args{'ircChannelCode'} );
			} 
		}
		elsif ( $action eq "del" ) {
			open (MODFILE, $brconfig::config_moderatorsfile);
			open (MODFILE2, '>'.$brconfig::config_moderatorsfile.'2');
			while (<MODFILE>) {
				chomp;
				$tmp = "$_";
				$tmp =~ s/\s+$//;
				$com = $tmp;
				$com =~ tr/A-Z/a-z/;
				if ( $com eq $nickcom ) { }
				else { print MODFILE2 "$tmp\n"; }
			}				
			close (MODFILE);
			close (MODFILE2);
			open (MODFILE, $brconfig::config_moderatorsfile.'2');
			open (MODFILE2, '>'.$brconfig::config_moderatorsfile);
			while (<MODFILE>) {
				chomp;
				$tmp = "$_";
				$tmp =~ s/\s+$//;
				print MODFILE2 "$tmp\n";	
			}				
			close (MODFILE);
			close (MODFILE2);
			plugin::ircmsg ( "[BR]".chr(2)." [ModControl]".chr(2).": $nick has been removed from the moderators list. Type !rehash when all changes are completed.", $args{'ircChannelCode'} );
		}
		else {
			plugin::ircmsg ( "[BR]".chr(2)." Usage".chr(2).": !admin <add|del> <nick> <level>", $args{'ircChannelCode'} );
		}
	}
	else {
		plugin::ircmsg ( "[BR]".chr(2)." Usage".chr(2).": !admin <add|del> <nick> <level>", $args{'ircChannelCode'} );		
	}
}

#ALWAYS need the following
1;